SystemOrganization addCategory: #MudTalk!
SystemOrganization addCategory: #'MudTalk-Client'!
SystemOrganization addCategory: #'MudTalk-Obsolete'!
SystemOrganization addCategory: #'MudTalk-Tests'!

StandardWindow subclass: #MudTalkClientWindow
	instanceVariableNames: 'inputPane outputPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientWindow methodsFor: 'private' stamp: 'AlexanderSvyazin 2/1/2013 07:14'!
inputPane
	^ inputPane ifNil: [
		inputPane := self newBasicTextEditorFor: self model getText: #getInput setText: #setInput:.
		inputPane textColor: Color white;
			acceptOnCR: true;
			alwaysAccept: true
			"layoutFrame: (LayoutFrame fractions: (1@1 extent: 1@1) offsets: (-50@0 extent: 50@0)) " ]! !

!MudTalkClientWindow methodsFor: 'keybindings' stamp: 'AlexanderSvyazin 1/14/2013 22:25'!
keyStroke: evt
	self eventHandler ifNotNil: [ :eventHandler |
		(eventHandler keyStroke: evt fromMorph: self) ifTrue: [^true] ].
	^ super keyStroke: evt! !

!MudTalkClientWindow methodsFor: 'initialization' stamp: 'AlexanderSvyazin 2/1/2013 07:34'!
on: aModel
	self model: aModel.
	self setLabel: 'MUD client';
		theme: MudTalkClientTheme new.
	self
		addMorph: self outputPane
		fullFrame: (LayoutFrame fractions: (0@0 extent: 1@0.75)).
	self
		addMorph: self inputPane
		fullFrame: (LayoutFrame fractions: (0@0.75 extent: 1@1))! !

!MudTalkClientWindow methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/28/2013 23:24'!
openInWorld
	super openInWorld.
	self inputPane takeKeyboardFocus! !

!MudTalkClientWindow methodsFor: 'private' stamp: 'AlexanderSvyazin 1/30/2013 22:51'!
outputPane
	^ outputPane ifNil: [
		outputPane := self newBasicTextEditorFor: self model getText: #getOutput setText: #setOutput:.
		outputPane textColor: Color white ]! !

!MudTalkClientWindow methodsFor: 'output' stamp: 'AlexanderSvyazin 1/28/2013 23:10'!
outputText: aText
	self outputPane appendText: aText! !

!MudTalkClientWindow methodsFor: 'output' stamp: 'AlexanderSvyazin 1/28/2013 23:10'!
outputText: aText withAttributes: attributes
	| textCopy |
	textCopy := aText copy.
	attributes do: [ :attr | textCopy addAttribute: attr ].
	self outputText: textCopy! !

!Symbol methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/13/2013 00:26'!
asKey
	^ MudTalkClientKey perform: self! !

!LogicalFontManager methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 21:22'!
fixedWidthFamilies
	^ self allFamilies select: [ :family |
		family members allSatisfy: [ :member | member isFixedWidth ] ].! !

PPToken subclass: #MudTalkEscapeToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkEscapeToken methodsFor: 'processing' stamp: 'AlexanderSvyazin 1/7/2013 21:51'!
triggerOn: aTarget 
	aTarget escape: self value! !

PPToken subclass: #MudTalkTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkTextToken methodsFor: 'processing' stamp: 'AlexanderSvyazin 1/7/2013 21:47'!
triggerOn: aTarget
	aTarget unescapedText: self value! !

PPToken subclass: #TelnetAoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetAoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:00'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ao! !

PPToken subclass: #TelnetAytToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetAytToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:01'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ayt! !

PPToken subclass: #TelnetBrkToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetBrkToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #brk! !

PPToken subclass: #TelnetDmToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDmToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:02'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dm! !

PPToken subclass: #TelnetDoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/25/2013 22:11'!
triggerOn: aEventManager
	aEventManager triggerEvent: #do: with: (self value first) asInteger.! !

PPToken subclass: #TelnetDontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetDontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/25/2013 22:10'!
triggerOn: aEventManager
	aEventManager triggerEvent: #dont: with: (self value first) asInteger.! !

PPToken subclass: #TelnetEcToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetEcToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ec! !

PPToken subclass: #TelnetElToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetElToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:05'!
triggerOn: aEventManager
	aEventManager triggerEvent: #el! !

PPToken subclass: #TelnetEorToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetEorToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 14:46'!
triggerOn: aEventManager
	aEventManager triggerEvent: #eor! !

PPToken subclass: #TelnetGaToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetGaToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ga! !

PPToken subclass: #TelnetIpToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetIpToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:06'!
triggerOn: aEventManager
	aEventManager triggerEvent: #ip! !

PPToken subclass: #TelnetNopToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetNopToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 11:07'!
triggerOn: aEventManager
	aEventManager triggerEvent: #nop! !

PPToken subclass: #TelnetSubnegoToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetSubnegoToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/5/2013 16:37'!
triggerOn: aEventManager
	aEventManager triggerEvent: #subnego: with: self value.! !

PPToken subclass: #TelnetTextToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetTextToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/4/2013 12:12'!
triggerOn: aEventManager
	aEventManager triggerEvent: #text: with: self value.! !

PPToken subclass: #TelnetWillToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetWillToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/25/2013 22:11'!
triggerOn: aEventManager
	aEventManager triggerEvent: #will: with: (self value first) asInteger.! !

PPToken subclass: #TelnetWontToken
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetWontToken methodsFor: 'events' stamp: 'AlexanderSvyazin 1/25/2013 22:10'!
triggerOn: aEventManager
	aEventManager triggerEvent: #wont: with: (self value first) asInteger.! !

TestCase subclass: #MudServerTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Tests'!

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/16/2012 23:22'!
testStartStop
	|server|
	server := MudServer new.
	server start.
	self should: [server isStarted].
	self shouldnt: [server isStopped].
	server stop.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!MudServerTests methodsFor: 'tests' stamp: 'AlexanderSvyazin 10/12/2012 23:20'!
testState
	|server|
	server := MudServer new.
	self should: [server isStopped].
	self shouldnt: [server isStarted].! !

!FontFamilyMemberAbstract methodsFor: '*MudTalk-Client' stamp: 'AlexanderSvyazin 1/4/2013 20:56'!
isFixedWidth
	^ (self respondsTo: #fileInfo) ifFalse: [ false ]
		ifTrue: [ self fileInfo fixedWidth ]! !

Object subclass: #ManifestMudTalk
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/20/2013 22:02'!
rejectClasses
^ #()! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/20/2013 22:02'!
rejectRules
^ #()! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 22:11'!
ruleConsistencyCheckRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#MudTalkClientMsspHandler #msspParam #false)) #'2013-01-25T22:10:30.109000001+06:00') #(#(#RGMethodDefinition #(#TelnetWontToken #triggerOn: #false)) #'2013-01-25T22:10:39.239+06:00') #(#(#RGMethodDefinition #(#MudTalkClientTheme #fixedWidthFontFamily #false)) #'2013-01-25T22:10:47.957+06:00') #(#(#RGMethodDefinition #(#TelnetDontToken #triggerOn: #false)) #'2013-01-25T22:10:55.994+06:00') #(#(#RGMethodDefinition #(#TelnetWillToken #triggerOn: #false)) #'2013-01-25T22:11:05.812+06:00') #(#(#RGMethodDefinition #(#TelnetDoToken #triggerOn: #false)) #'2013-01-25T22:11:13.811+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 22:08'!
ruleGuardClauseRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#MudTalkClientMsspHandler #subnego:data: #false)) #'2013-01-25T22:07:34.771000001+06:00') #(#(#RGMethodDefinition #(#MudTalkClientTerminalTypeHandler #will: #false)) #'2013-01-25T22:08:15.135+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 21:47'!
ruleIfTrueBlocksRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#MudTalkClientKey #matchEvent: #false)) #'2013-01-25T21:47:31.026+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 21:49'!
ruleMissingYourselfRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#MudTalkClient #unknownCommand: #false)) #'2013-01-25T21:49:58.482000006+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 22:01'!
ruleRefersToClassRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#TelnetStream #initialize #false)) #'2013-01-25T21:53:57.397000001+06:00') #(#(#RGMethodDefinition #(#TelnetStream #iacNext #false)) #'2013-01-25T21:54:14.794+06:00') #(#(#RGMethodDefinition #(#TelnetStream #iacSbNext #false)) #'2013-01-25T21:54:25.556+06:00') #(#(#RGMethodDefinition #(#TelnetStream #next #false)) #'2013-01-25T21:54:35.983+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #parser #true)) #'2013-01-25T21:54:57.06+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #subnego #true)) #'2013-01-25T21:55:13.311+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #ip #true)) #'2013-01-25T21:55:29.312+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #sb #true)) #'2013-01-25T21:55:44.187+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #text #true)) #'2013-01-25T21:56:01.04+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #ao #true)) #'2013-01-25T21:56:19.432+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #eor #true)) #'2013-01-25T21:56:30.98+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #ayt #true)) #'2013-01-25T21:56:43.037+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #ga #true)) #'2013-01-25T21:56:57.81+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #iac #true)) #'2013-01-25T21:57:05.33+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #brk #true)) #'2013-01-25T21:57:18.613+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #el #true)) #'2013-01-25T21:57:31.08+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #will #true)) #'2013-01-25T21:57:46.408+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #se #true)) #'2013-01-25T21:57:58.729+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #iaciac #true)) #'2013-01-25T21:58:13.811+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #ec #true)) #'2013-01-25T21:58:26.094+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #normalChar #true)) #'2013-01-25T21:58:36.572+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #eorDelimiter #true)) #'2013-01-25T21:58:48.779+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #special #true)) #'2013-01-25T21:59:38.3+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #nop #true)) #'2013-01-25T21:59:54.474+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #dm #true)) #'2013-01-25T22:00:08.317+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #do #true)) #'2013-01-25T22:00:22.949+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #dont #true)) #'2013-01-25T22:00:36.661+06:00') #(#(#RGMethodDefinition #(#'TelnetParser class' #wont #true)) #'2013-01-25T22:00:50.909+06:00') #(#(#RGMethodDefinition #(#'TelnetStream class' #subnegoEnd #true)) #'2013-01-25T22:01:03.837+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 21:34'!
ruleSentNotImplementedRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#TelnetStream #iacNext #false)) #'2013-01-25T21:34:40.886000004+06:00') )! !

!ManifestMudTalk class methodsFor: 'meta data' stamp: 'AlexanderSvyazin 1/25/2013 22:02'!
ruleVariableReferencedOnceRuleV1TruePositive
^ #(#(#(#RGMethodDefinition #(#MudTalkConnectionToServer #connectTo:port: #false)) #'2013-01-25T22:02:39.597+06:00') )! !

Object subclass: #MudServer
	instanceVariableNames: 'started'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!MudServer methodsFor: 'initialize-release' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
initialize
	started := false.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:23'!
isStarted
	^ started.! !

!MudServer methodsFor: 'state' stamp: 'AlexanderSvyazin 10/12/2012 23:21'!
isStopped
	^ started not.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:32'!
start
	started := true.! !

!MudServer methodsFor: 'start-stop' stamp: 'AlexanderSvyazin 10/12/2012 23:33'!
stop
	started := false.! !

Object subclass: #MudTalkClient
	instanceVariableNames: 'window server commandHandlers escapeParser escapeTextAttributes textAttributes keyBindings msspParams telnetSettings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClient class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/4/2013 22:25'!
openWindowOnHost: aByteString port: aSmallInteger 
	self new openWindowOnHost: aByteString port: aSmallInteger.! !

!MudTalkClient methodsFor: 'keybinding' stamp: 'AlexanderSvyazin 1/13/2013 23:20'!
actionForEvent: evt ifPresent: anAction 
	self keyBindings do: [ :keyBinding |
		(keyBinding matchEvent: evt) ifTrue: [ anAction value: (keyBinding action) ] ]! !

!MudTalkClient methodsFor: 'keybinding' stamp: 'AlexanderSvyazin 1/13/2013 21:56'!
bindKey: aKey to: anAction 
	self keyBindings add: (MudTalkClientKeyBinding new key: aKey action: anAction)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/27/2013 18:18'!
bindStandardKeys
	self
		bindKey: #num2 asKey to: [ self serverText: 'south' ];
		bindKey: #num8 asKey to: [ self serverText: 'north' ];
		bindKey: #num4 asKey to: [ self serverText: 'west' ];
		bindKey: #num6 asKey to: [ self serverText: 'east' ];
		bindKey: #num7 asKey to: [ self serverText: 'northwest' ];
		bindKey: #num9 asKey to: [ self serverText: 'northeast' ];
		bindKey: #num1 asKey to: [ self serverText: 'southwest' ];
		bindKey: #num3 asKey to: [ self serverText: 'southeast' ]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 22:22'!
command: aTelnetCommand
	self commandHandlers
		at: aTelnetCommand
		ifPresent: [ :handler | handler value: aTelnetCommand ]
		ifAbsent: [ self unknownCommand: aTelnetCommand ]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 16:12'!
commandHandlers
	^ commandHandlers ifNil: [ commandHandlers := Dictionary new ]! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 2/2/2013 17:21'!
connectTo: aHost port: aPort
	server := MudTalkConnectionToServer new.
	server events
		when: #disconnected send: #disconnected to: self;
		when: #do: send: #do: to: self;
		when: #dont: send: #dont: to: self;
		when: #will: send: #will: to: self;
		when: #wont: send: #wont: to: self;
		when: #subnego:data: send: #subnego:data: to: self;
		when: #command: send: #command: to: self;
		when: #text: send: #text: to: self.
	server connectTo: aHost port: aPort! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/4/2013 21:48'!
connectionClosedText
	^ '******* CONNECTION CLOSED *******' asText addAttribute: (TextColor color: Color red)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/10/2013 22:17'!
defaultTextAttribute
	^ TextColor color: Color white! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/5/2013 15:23'!
disconnect
	server ifNotNil: [ server terminate ].! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 2/2/2013 17:27'!
disconnected
	self window outputText: self connectionClosedText! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:15'!
do: anOption
	telnetSettings ifOption: anOption
		unknown: [self unknownDo: anOption]
		disabled: [server wont: anOption]
		ignored: [^self]
		enabled: [:handler | handler do: anOption from: server]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:15'!
dont: anOption
	telnetSettings ifOption: anOption
		unknown: [self unknownDont: anOption]
		disabled: [server wont: anOption]
		ignored: [^self]
		enabled: [:handler | handler dont: anOption from: server]! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:40'!
escape: aByteString
	| attributes |
	attributes := self escapeParser textAttributeParser parse: aByteString.
	attributes isPetitFailure
		ifTrue: [ self trace: 'unknown escape: '; traceCr: aByteString ]
		ifFalse: [ self textAttributes: attributes ]! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/7/2013 21:46'!
escapeParser
	^ escapeParser ifNil: [ escapeParser := MudTalkEscapeParser new ]! !

!MudTalkClient methodsFor: 'input' stamp: 'AlexanderSvyazin 1/2/2013 17:48'!
getInput
	^nil.! !

!MudTalkClient methodsFor: 'output' stamp: 'AlexanderSvyazin 1/28/2013 23:16'!
getOutput
	^ nil! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 2/2/2013 17:21'!
initialize
	super initialize.
	self initializeTelnetSettings.
	self initializeEscapeTextAttributes.
	self initializeTextAttributes.
	self initializeKeybindings! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/9/2013 23:47'!
initializeEscapeTextAttributes
	escapeTextAttributes := Dictionary new.
	escapeTextAttributes
		at: 0 put: self defaultTextAttribute;
		at: 1 put: TextEmphasis bold;
		at: 30 put: (TextColor color: Color black);
		at: 31 put: (TextColor color: Color red);
		at: 32 put: (TextColor color: Color green);
		at: 33 put: (TextColor color: Color yellow);
		at: 34 put: (TextColor color: Color blue);
		at: 35 put: (TextColor color: Color magenta);
		at: 36 put: (TextColor color: Color cyan);
		at: 37 put: (TextColor color: Color white)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/27/2013 18:24'!
initializeKeybindings
	self window on: #keyStroke send: #keyStroke: to: self.
	self bindStandardKeys! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 2/2/2013 17:19'!
initializeTelnetSettings
	| terminalTypeHandler suppressGoAheadHandler |
	telnetSettings := MudTalkClientTelnetSettings new.
	telnetSettings
		disableOption: TelnetOption naws;
		disableOption: TelnetOption compress;
		disableOption: TelnetOption compress2;
		disableOption: TelnetOption echo;
		enableOption: TelnetOption terminalType
			withHandler: MudTalkClientTerminalTypeHandler new;
		enableOption: TelnetOption suppressGoAhead
			withHandler: (MudTalkClientSuppressGoAheadHandler new client: self)! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/9/2013 23:47'!
initializeTextAttributes
	textAttributes := { self defaultTextAttribute }! !

!MudTalkClient methodsFor: 'private' stamp: 'AlexanderSvyazin 1/10/2013 22:39'!
inputAttributes
	^ { TextColor color: Color lightBrown }! !

!MudTalkClient methodsFor: 'keybinding' stamp: 'AlexanderSvyazin 1/13/2013 21:57'!
keyBindings
	^ keyBindings ifNil: [ keyBindings := OrderedCollection new ]! !

!MudTalkClient methodsFor: 'keybinding' stamp: 'AlexanderSvyazin 1/27/2013 18:46'!
keyStroke: evt
	self actionForEvent: evt ifPresent: [ :handler | handler value. ^true ].
	^ false! !

!MudTalkClient methodsFor: 'mssp' stamp: 'AlexanderSvyazin 1/18/2013 22:20'!
msspParamsReceived: msspParamsCollection
	msspParams := msspParamsCollection.
	msspParams do: [ :param |
		self trace: param name;
			trace: ' = ';
			traceCr: param values ]! !

!MudTalkClient methodsFor: 'initialization' stamp: 'AlexanderSvyazin 2/2/2013 15:17'!
openWindowOnHost: aHost port: aPort
	self connectTo: (NetNameResolver addressForName: aHost) port: aPort.
	self window openInWorld! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/5/2013 15:25'!
server
	^ server! !

!MudTalkClient methodsFor: 'connection' stamp: 'AlexanderSvyazin 1/30/2013 23:03'!
serverText: aText
	| textForOutput |
	textForOutput := aText copy asText.
	textForOutput append: String cr.
	window outputText: textForOutput withAttributes: self inputAttributes.
	server text: aText! !

!MudTalkClient methodsFor: 'input' stamp: 'AlexanderSvyazin 2/1/2013 21:55'!
setInput: aText
	self serverText: aText.
	self changed: #getInput! !

!MudTalkClient methodsFor: 'output' stamp: 'AlexanderSvyazin 1/28/2013 23:15'!
setOutput: aModel! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:15'!
subnego: anOption data: aByteString
	telnetSettings ifOption: anOption
		unknown: [self unknownSubnego: anOption]
		disabled: [^self]
		ignored: [^self]
		enabled: [:handler | handler subnego: anOption data: aByteString from: server]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/11/2013 12:49'!
text: aText
	| tokens |
	tokens := self escapeParser parse: aText.
	tokens do: [ :token | token triggerOn: self ].! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:48'!
textAttributes: newAttributeCodes
	| newAttributes |
	newAttributes := OrderedCollection new.
	newAttributeCodes do: [ :each | escapeTextAttributes
		at: each
		ifPresent: [ :attr | newAttributes add: attr ] ].
	textAttributes := newAttributes asArray! !

!MudTalkClient methodsFor: 'escape parsing' stamp: 'AlexanderSvyazin 1/28/2013 23:11'!
unescapedText: aString
	self window outputText: aString asText withAttributes: textAttributes! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/25/2013 21:49'!
unknownCommand: aTelnetCommand
	self
		trace: 'unknown telnet command: ';
		traceCr: aTelnetCommand! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 16:28'!
unknownDo: anOption
	self trace: 'unknown DO: ';
		traceCr: anOption! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 16:29'!
unknownDont: anOption
	self trace: 'unknown DONT: ';
		traceCr: anOption! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 16:30'!
unknownSubnego: anOption
	self trace: 'unknown SUBNEGO: ';
		traceCr: anOption! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 16:29'!
unknownWill: anOption
	self trace: 'unknown WILL: ';
		traceCr: anOption! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 16:29'!
unknownWont: anOption
	self trace: 'unknown WONT: ';
		traceCr: anOption! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:15'!
will: anOption
	telnetSettings ifOption: anOption
		unknown: [self unknownWill: anOption]
		disabled: [server dont: anOption]
		ignored: [^self]
		enabled: [:handler | handler will: anOption from: server]! !

!MudTalkClient methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/28/2013 23:08'!
window
	^ window ifNil: [ window := MudTalkClientWindow new on: self ]! !

!MudTalkClient methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:15'!
wont: anOption
	telnetSettings ifOption: anOption
		unknown: [self unknownWont: anOption]
		disabled: [server dont: anOption]
		ignored: [^self]
		enabled: [:handler | handler wont: anOption from: server]! !

MudTalkClient subclass: #MudTalkMateriaMagica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkMateriaMagica methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/11/2013 12:03'!
initialize
	super initialize.
	self openWindowOnHost: 'materiamagica.com' port: 4000! !

MudTalkClient subclass: #MudTalkTwoTowers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkTwoTowers methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/11/2013 11:53'!
initialize
	super initialize.
	self openWindowOnHost: 't2tmud.org' port: 9999! !

Object subclass: #MudTalkClientKey
	instanceVariableNames: 'keyValue scanCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:44'!
num0
	^ self new keyValue: 16r30; scanCode: 82! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num1
	^ self new keyValue: 16r31; scanCode: 83! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num2
	^ self new keyValue: 16r32; scanCode: 84! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num3
	^ self new keyValue: 16r33; scanCode: 85! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num4
	^ self new keyValue: 16r34; scanCode: 86! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num5
	^ self new keyValue: 16r35; scanCode: 87! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num6
	^ self new keyValue: 16r36; scanCode: 88! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num7
	^ self new keyValue: 16r37; scanCode: 89! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:45'!
num8
	^ self new keyValue: 16r38; scanCode: 91! !

!MudTalkClientKey class methodsFor: 'numpad' stamp: 'AlexanderSvyazin 1/27/2013 18:46'!
num9
	^ self new keyValue: 16r39; scanCode: 92! !

!MudTalkClientKey methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/13/2013 15:14'!
keyValue
	^ keyValue! !

!MudTalkClientKey methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/13/2013 15:13'!
keyValue: aKeyValue
	keyValue := aKeyValue! !

!MudTalkClientKey methodsFor: 'matching' stamp: 'AlexanderSvyazin 1/25/2013 21:47'!
matchEvent: evt
	^ (scanCode isNil or: [scanCode = evt scanCode]) and:
		[keyValue isNil or: [keyValue = evt keyValue]]! !

!MudTalkClientKey methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/14/2013 21:46'!
scanCode: aScanCode
	scanCode := aScanCode! !

Object subclass: #MudTalkClientKeyBinding
	instanceVariableNames: 'key action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientKeyBinding methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/13/2013 23:25'!
action
	^ action! !

!MudTalkClientKeyBinding methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/27/2013 18:15'!
key: aKey action: anAction
	key := aKey.
	action := anAction! !

!MudTalkClientKeyBinding methodsFor: 'matching' stamp: 'AlexanderSvyazin 1/13/2013 23:22'!
matchEvent: evt 
	^ self key matchEvent: evt! !

Object subclass: #MudTalkClientTelnetOptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

MudTalkClientTelnetOptionHandler subclass: #MudTalkClientDisabledOptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientDisabledOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:58'!
isDisabled
	^ true! !

MudTalkClientTelnetOptionHandler subclass: #MudTalkClientEnabledOptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientEnabledOptionHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:16'!
do: anOption from: server
	server will: anOption! !

!MudTalkClientEnabledOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 16:01'!
isEnabled
	^ true! !

!MudTalkClientEnabledOptionHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:16'!
subnego: anOption data: aByteString from: server
	self subclassResponsibility! !

!MudTalkClientEnabledOptionHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:16'!
will: anOption from: server
	server do: anOption! !

MudTalkClientEnabledOptionHandler subclass: #MudTalkClientMsspHandler
	instanceVariableNames: 'events'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientMsspHandler class methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:29'!
MSSP_VAL
	^ Character value: 2! !

!MudTalkClientMsspHandler class methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:28'!
MSSP_VAR
	^ Character value: 1! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:29'!
anyChar
	^ PPPredicateObjectParser anyExceptAnyOf: { self class MSSP_VAR. self class MSSP_VAL }! !

!MudTalkClientMsspHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/18/2013 22:12'!
events
	^ events ifNil: [ events := EventManager new ]! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/17/2013 21:42'!
makeMsspParam: paramName value: paramValues
	^ MudTalkMsspParam new name: paramName values: paramValues! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/25/2013 22:10'!
msspParam
	^ self msspVar, (self msspVal star) ==> [ :tokens |
		self makeMsspParam: (tokens first) value: (tokens second) ]! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:48'!
msspParser
	^ self msspParam star end! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:52'!
msspVal
	^ self class MSSP_VAL asParser, (self anyChar star flatten) ==> #second! !

!MudTalkClientMsspHandler methodsFor: 'parsing' stamp: 'AlexanderSvyazin 1/10/2013 17:43'!
msspVar
	^ self class MSSP_VAR asParser, (self anyChar plus flatten) ==> #second! !

!MudTalkClientMsspHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/18/2013 22:14'!
params: paramsCollection
	self events triggerEvent: #msspParams: with: paramsCollection! !

!MudTalkClientMsspHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:17'!
subnego: anOption data: msspData from: server
	| tokens |
	tokens := self msspParser parse: msspData.
	self params: tokens! !

MudTalkClientEnabledOptionHandler subclass: #MudTalkClientSuppressGoAheadHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientSuppressGoAheadHandler methodsFor: 'accessing' stamp: 'AlexanderSvyazin 2/2/2013 17:17'!
client: aClient
	aClient commandHandlers at: TelnetCommand GA put: [ :command | self ga ]! !

!MudTalkClientSuppressGoAheadHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/7/2013 16:15'!
ga
	self traceCr: 'GA command received'! !

MudTalkClientEnabledOptionHandler subclass: #MudTalkClientTerminalTypeHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 16:34'!
bytesForSend
	^ {(TelnetTerminalType send)} asByteArray! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/5/2013 18:11'!
clientTerminalType
	^ 'MudTalk v0.1'! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:18'!
subnego: option data: aByteString from: server
	server subnegoStream: [ :stream |
		stream nextPut: TelnetOption terminalType;
			nextPut: TelnetTerminalType is;
			nextPutAll: self clientTerminalType ]! !

!MudTalkClientTerminalTypeHandler methodsFor: 'telnet' stamp: 'AlexanderSvyazin 2/2/2013 17:18'!
will: option from: server
	super will: option from: server.
	server subnego: self bytesForSend option: TelnetOption terminalType! !

MudTalkClientTelnetOptionHandler subclass: #MudTalkClientIgnoredOptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientIgnoredOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:59'!
isIgnored
	^ true! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:55'!
ifDisabled: aBlock
	self isDisabled ifTrue: aBlock! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:56'!
ifEnabled: aBlock
	self isEnabled ifTrue: [aBlock value: self]! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:55'!
ifIgnored: aBlock
	self isIgnored ifTrue: aBlock! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 17:05'!
isDisabled
	^ false! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 17:05'!
isEnabled
	^ false! !

!MudTalkClientTelnetOptionHandler methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 17:05'!
isIgnored
	^ false! !

Object subclass: #MudTalkClientTelnetSettings
	instanceVariableNames: 'handlers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 15:52'!
disableOption: anOption
	self setHandler: MudTalkClientDisabledOptionHandler new for: anOption! !

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 17:02'!
enableOption: anOption withHandler: handler
	self setHandler: handler for: anOption! !

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 16:47'!
handlerFor: anOption 
	handlers at: anOption
		ifPresent: [:handler | ^handler]
		ifAbsent: [^nil]
! !

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 16:49'!
ifOption: anOption unknown: unknownBlock disabled: disabledBlock ignored: ignoredBlock enabled: enabledBlock
	(self handlerFor: anOption)
		ifNil: [^unknownBlock value];
		ifDisabled: [^disabledBlock value];
		ifIgnored: [^ignoredBlock value];
		ifEnabled: enabledBlock! !

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 16:03'!
ignoreOption: anOption
	self setHandler: MudTalkClientIgnoredOptionHandler new for: anOption! !

!MudTalkClientTelnetSettings methodsFor: 'initialization' stamp: 'AlexanderSvyazin 2/2/2013 16:09'!
initialize
	super initialize.
	handlers := Dictionary new! !

!MudTalkClientTelnetSettings methodsFor: 'telnet options' stamp: 'AlexanderSvyazin 2/2/2013 16:08'!
setHandler: aHandler for: anOption
	handlers at: anOption put: aHandler! !

Object subclass: #MudTalkConnectionToServer
	instanceVariableNames: 'events telnetStream stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkConnectionToServer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/25/2013 22:02'!
connectTo: aHost port: aPort
	stream := SocketStream openConnectionToHost: aHost port: aPort.
	stream noTimeout.
	telnetStream := TelnetStream on: stream.
	[ self networkReadLoop ] forkNamed: 'MUD client network reading process'! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
do: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser doChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
dont: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser dontChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:08'!
events
	^ events ifNil: [ events := EventManager new ]! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/6/2013 23:06'!
networkReadLoop
	[ [ self processTelnetToken ] repeat ]
		on: NetworkError
		do: [ self events triggerEvent: #disconnected ]! !

!MudTalkConnectionToServer methodsFor: 'private' stamp: 'AlexanderSvyazin 1/6/2013 23:06'!
processTelnetToken
	| token |
	token := telnetStream next.
	token triggerOn: self events.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/5/2013 17:35'!
subnego: aByteArray
	self subnegoStream: [ :strm | strm nextPutAll: aByteArray ].! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/5/2013 17:37'!
subnego: aByteArray option: anOption
	self subnegoStream: [ :strm | strm nextPut: anOption; nextPutAll: aByteArray ]! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
subnegoStream: aBlock
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser sbChar.
	aBlock value: stream.
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser seChar; flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
text: aText
	stream nextPutAll: aText; crlf; flush! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
will: option 
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser willChar;
		nextPut: (Character value: option);
		flush.! !

!MudTalkConnectionToServer methodsFor: 'server' stamp: 'AlexanderSvyazin 1/6/2013 23:40'!
wont: option
	stream nextPut: TelnetParser iacChar;
		nextPut: TelnetParser wontChar;
		nextPut: (Character value: option);
		flush.! !

Object subclass: #MudTalkEscapeParser
	instanceVariableNames: 'parser textAttributeParser textBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkEscapeParser methodsFor: 'common' stamp: 'AlexanderSvyazin 1/7/2013 21:00'!
CSI
	^ (Character value: 16r1B) asParser, (Character value: 16r5B) asParser! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 20:57'!
F
	^ PPPredicateObjectParser between: (Character value: 16r40) and: (Character value: 16r7E)! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 20:56'!
I
	^ PPPredicateObjectParser between: (Character value: 16r20) and: (Character value: 16r2F)! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 20:55'!
P
	^ PPPredicateObjectParser between: (Character value: 16r30) and: (Character value: 16r3F)! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/8/2013 17:07'!
escapeParser
	^ (self CSI, self P star, self I star, self F) token: MudTalkEscapeToken! !

!MudTalkEscapeParser methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/11/2013 13:05'!
initialize
	textBuffer := ''! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/11/2013 12:28'!
newParser
	^ (self escapeParser / self text) plus! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:12'!
newTextAttributeParser
	^ (self CSI , self numbers , self textAttributeFinisher) end ==> #third! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 21:32'!
normalChar
	^ (Character value: 16r1B) asParser negate! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/11/2013 13:02'!
number
	^ #digit asParser plus flatten ==> [ :str | str asInteger ].! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:07'!
numbers
	^ (self number separatedBy: self textAttributeDelimiter) ==>
		[ :node | node select: [ :each | each isInteger ] ]! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/11/2013 13:04'!
parse: aText
	| petitStream result |
	petitStream := (textBuffer, aText) asPetitStream.
	result := self parser parse: petitStream.
	textBuffer := String withAll: petitStream upToEnd.
	^ result! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 20:31'!
parser
	^ parser ifNil: [ parser := self newParser ]! !

!MudTalkEscapeParser methodsFor: 'base' stamp: 'AlexanderSvyazin 1/7/2013 21:39'!
text
	^ self normalChar plus ==> [ :chars | MudTalkTextToken on: (String withAll: chars)]! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/8/2013 15:36'!
textAttributeDelimiter
	^ $; asParser! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/8/2013 15:37'!
textAttributeFinisher
	^ $m asParser! !

!MudTalkEscapeParser methodsFor: 'attribute parsing' stamp: 'AlexanderSvyazin 1/8/2013 16:31'!
textAttributeParser
	^ textAttributeParser ifNil: [ textAttributeParser := self newTextAttributeParser ]! !

Object subclass: #MudTalkMsspParam
	instanceVariableNames: 'name values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkMsspParam methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/18/2013 22:22'!
name
	^ name! !

!MudTalkMsspParam methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/10/2013 18:16'!
name: paramName values: paramValues 
	name := paramName.
	values := paramValues! !

!MudTalkMsspParam methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/18/2013 22:22'!
values
	^ values! !

Object subclass: #TelnetCharBuffer
	instanceVariableNames: 'position buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetCharBuffer methodsFor: 'writing' stamp: 'AlexanderSvyazin 1/7/2013 15:22'!
add: aCharacter 
	buffer at: position put: aCharacter.
	position := position + 1! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:51'!
clear
	| savedPosition |
	savedPosition := position - 1.
	position := 1.
	^ TelnetText on: buffer from: 1 to: savedPosition! !

!TelnetCharBuffer methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
initialize
	buffer := Array new: self size.
	position := 1.! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
isEmpty
	^ position = 1! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:23'!
isFull
	^ position > self size! !

!TelnetCharBuffer methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:19'!
size
	^ 4096! !

Object subclass: #TelnetCommand
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetCommand class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/7/2013 16:11'!
GA
	^ 249! !

!TelnetCommand class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 16:16'!
value: aCommand 
	^ self new value: aCommand! !

!TelnetCommand methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #command: with: self value! !

!TelnetCommand methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:58'!
value
	^ value! !

!TelnetCommand methodsFor: 'initialize' stamp: 'AlexanderSvyazin 1/6/2013 16:15'!
value: aCommand 
	value := aCommand! !

Object subclass: #TelnetDo
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDo class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 23:38'!
option: anOption 
	^ self new option: anOption! !

!TelnetDo methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:39'!
option
	^ option! !

!TelnetDo methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:37'!
option: anOption 
	option := anOption! !

!TelnetDo methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #do: with: self option! !

Object subclass: #TelnetDont
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetDont methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/25/2013 21:40'!
option
	^ option! !

!TelnetDont methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/25/2013 21:40'!
option: anOption
	option := anOption! !

!TelnetDont methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:22'!
triggerOn: aEventSource
	aEventSource triggerEvent: #dont: with: self option! !

Object subclass: #TelnetOption
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
compress
	^ 85.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/18/2013 22:32'!
compress2
	^ 86.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 2/2/2013 16:55'!
echo
	^ 1! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 15:29'!
eor
	^ 25.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
gmcp
	^ 201.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
msp
	^ 90.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/10/2013 17:10'!
mssp
	^ 70! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:03'!
mxp
	^ 91.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 23:02'!
naws
	^ 31.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 13:27'!
suppressGoAhead
	^ 3.! !

!TelnetOption class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:08'!
terminalType
	^ 24.! !

Object subclass: #TelnetParser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Obsolete'!

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/3/2013 23:04'!
anyToken: aTokenClass
	^ #any asParser token: aTokenClass.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:56'!
ao
	^ (self class iac, self class aoChar asParser) token: TelnetAoToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aoChar
	^ Character value: 245.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:56'!
ayt
 	^ (self class iac, self class aytChar asParser) token: TelnetAytToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
aytChar
	^ Character value: 246.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:57'!
brk
	^ (self class iac, self class brkChar asParser) token: TelnetBrkToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
brkChar
	^ Character value: 243.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 22:00'!
dm
	^ (self class iac, self class dmChar asParser) token: TelnetDmToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dmChar
	^ Character value: 242.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 22:00'!
do
	^ (self class iac,
		self class doChar asParser,
		(self class anyToken: TelnetDoToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
doChar
	^ Character value: 253.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 22:00'!
dont
	^ (self class iac,
		self class dontChar asParser,
		(self class anyToken: TelnetDontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
dontChar
	^ Character value: 254.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:58'!
ec
	^ (self class iac, self class ecChar asParser) token: TelnetEcToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ecChar
	^ Character value: 247.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:57'!
el
	^ (self class iac, self class elChar asParser) token: TelnetElToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
elChar
	^ Character value: 248.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:56'!
eor
	^ (self class iac, self class eorChar asParser) token: TelnetEorToken.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 14:44'!
eorChar
	^ Character value: 239.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/25/2013 21:58'!
eorDelimiter
	^ String with: self class iacChar with: self class eorChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:56'!
ga
	^ (self class iac, self class gaChar asParser) token: TelnetGaToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
gaChar
	^ Character value: 249.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:57'!
iac
	^ self class iacChar asParser.! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
iacChar
	^ Character value: 255.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:58'!
iaciac
	^ (self class iac, self class iac)
		answer: self class iacChar.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:55'!
ip
	^ (self class iac, self class ipChar asParser) token: TelnetIpToken! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
ipChar
	^ Character value: 244.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:59'!
nop
	^ (self class iac, self class nopChar asParser) token: TelnetNopToken! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
nopChar
	^ Character value: 241.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:58'!
normalChar
	^ self class iaciac / self class iac negate.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:54'!
parser
	^ (self class special / self class text) star end.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:55'!
sb
	^ (self class iac, self class sbChar asParser) answer: #sb! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
sbChar
	^ Character value: 250.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:57'!
se
	^ (self class iac, self class seChar asParser) answer: #se! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
seChar
	^ Character value: 240.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:59'!
special
	^ self class nop /
		self class dm /
		self class brk /
		self class ip /
		self class ao /
		self class ayt /
		self class ec /
		self class el /
		self class ga /
		self class do /
		self class dont /
		self class will /
		self class wont /
		self class subnego! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:55'!
subnego
	^ self class sb, (self class normalChar plus token: TelnetSubnegoToken), self class se ==>
		[ :parts | parts at: 2 ]! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:56'!
text
	^ self class normalChar plus ==> [:chars | TelnetTextToken on: (String withAll: chars)].! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 21:57'!
will
	^ (self class iac,
		self class willChar asParser,
		(self class anyToken: TelnetWillToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/4/2013 11:31'!
willChar
	^ Character value: 251.! !

!TelnetParser class methodsFor: 'parsers' stamp: 'AlexanderSvyazin 1/25/2013 22:00'!
wont
	^ (self class iac,
		self class wontChar asParser,
		(self class anyToken: TelnetWontToken)) ==>
			[:parts | parts at: 3].! !

!TelnetParser class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/2/2013 23:55'!
wontChar
	^ Character value: 252.! !

Object subclass: #TelnetStream
	instanceVariableNames: 'stream iacHandlers charBuffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
DO
	^ Character value: 253.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
DONT
	^ Character value: 254.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 15:39'!
IAC
	^ Character value: 255! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
SB
	^ Character value: 250.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
SE
	^ Character value: 240.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
WILL
	^ Character value: 251.! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/6/2013 16:10'!
WONT
	^ Character value: 252 .! !

!TelnetStream class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/6/2013 16:21'!
on: aSource 
	^ self new source: aSource! !

!TelnetStream class methodsFor: 'telnet' stamp: 'AlexanderSvyazin 1/27/2013 18:39'!
subnegoEnd
	^ {self IAC. self SE}! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
iacDoNext
	^ TelnetDo option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
iacDontNext
	^ TelnetDont option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/25/2013 21:54'!
iacNext
	| c |
	c := stream next.
	(c = self class IAC)
		ifTrue: [
			charBuffer add: self class IAC.
			charBuffer isFull ifTrue: [ ^ charBuffer clear ].
			^ self next ]
		ifFalse: [
			iacHandlers at: c
				ifPresent: [ :handler | ^ handler value ]
				ifAbsent: [ ^ TelnetCommand value: c asInteger ] ]
	! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/25/2013 21:54'!
iacSbNext
	| option data |
	option := self readOption.
	data := stream upToAll: self class subnegoEnd.
	^ TelnetSubnego option: option data: data! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:01'!
iacWillNext
	^ TelnetWill option: self readOption! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:01'!
iacWontNext
	^ TelnetWont option: self readOption! !

!TelnetStream methodsFor: 'initializing' stamp: 'AlexanderSvyazin 1/27/2013 18:39'!
initialize
	super initialize.
	charBuffer := TelnetCharBuffer new.
	iacHandlers := Dictionary new.
	iacHandlers at: self class DO put: [ self iacDoNext ].
	iacHandlers at: self class DONT put: [ self iacDontNext ].
	iacHandlers at: self class WILL put: [ self iacWillNext ].
	iacHandlers at: self class WONT put: [ self iacWontNext ].
	iacHandlers at: self class SB put: [ self iacSbNext ].! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/25/2013 21:54'!
next
	| c |
	[ stream isDataAvailable ifFalse: [ charBuffer isEmpty ifFalse: [ ^ charBuffer clear ] ].
		c := stream next.
		(c = self class IAC) ifTrue: [ ^ self iacNext ].
		charBuffer add: c.
		charBuffer isFull ifTrue: [ ^ charBuffer clear ] ] repeat.! !

!TelnetStream methodsFor: 'reading' stamp: 'AlexanderSvyazin 1/6/2013 16:00'!
readOption
	^ stream next asInteger! !

!TelnetStream methodsFor: 'initializing' stamp: 'AlexanderSvyazin 1/6/2013 16:21'!
source: aSource 
	stream := aSource! !

Object subclass: #TelnetSubnego
	instanceVariableNames: 'option data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetSubnego class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 15:31'!
option: anOption data: aByteString
	^ self new option: anOption data: aByteString! !

!TelnetSubnego methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:33'!
data
	^ data! !

!TelnetSubnego methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:33'!
option
	^ option! !

!TelnetSubnego methodsFor: 'events' stamp: 'AlexanderSvyazin 1/7/2013 15:32'!
option: anOption data: aByteString
	option := anOption.
	data := aByteString.! !

!TelnetSubnego methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:34'!
triggerOn: aEventSource
	aEventSource triggerEvent: #subnego:data: withArguments: {self option. self data}! !

Object subclass: #TelnetTerminalType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 18:10'!
is
	^ 0.! !

!TelnetTerminalType class methodsFor: 'constants' stamp: 'AlexanderSvyazin 1/5/2013 16:19'!
send
	^ 1.! !

Object subclass: #TelnetText
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetText class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 15:37'!
on: aCollection from: start to: stop
	^ self new on: aCollection from: start to: stop! !

!TelnetText methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/7/2013 15:41'!
collection
	^ collection! !

!TelnetText methodsFor: 'events' stamp: 'AlexanderSvyazin 1/7/2013 15:45'!
on: aCollection from: start to: stop 
	collection := aCollection copyFrom: start to: stop! !

!TelnetText methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 15:46'!
triggerOn: anEventSource
	anEventSource triggerEvent: #text: with: (String withAll: self collection)! !

Object subclass: #TelnetWill
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWill class methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:41'!
option: anOption 
	^ self new option: anOption! !

!TelnetWill methodsFor: 'accessing' stamp: 'AlexanderSvyazin 1/6/2013 23:42'!
option
	^ option! !

!TelnetWill methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/6/2013 23:42'!
option: anOption 
	option := anOption! !

!TelnetWill methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:25'!
triggerOn: aEventSource
	aEventSource triggerEvent: #will: with: self option! !

Object subclass: #TelnetWont
	instanceVariableNames: 'option'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk'!

!TelnetWont class methodsFor: 'instance creation' stamp: 'AlexanderSvyazin 1/7/2013 16:18'!
option: anOption 
	^ self new option: anOption! !

!TelnetWont methodsFor: 'accesing' stamp: 'AlexanderSvyazin 1/7/2013 16:19'!
option
	^ option! !

!TelnetWont methodsFor: 'initialization' stamp: 'AlexanderSvyazin 1/7/2013 16:19'!
option: anOption 
	option := anOption! !

!TelnetWont methodsFor: 'events' stamp: 'AlexanderSvyazin 1/6/2013 23:25'!
triggerOn: aEventSource
	aEventSource triggerEvent: #wont: with: self option! !

PharoTheme subclass: #MudTalkClientTheme
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MudTalk-Client'!

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/26/2013 00:35'!
fixedWidthFontFamily
	^ LogicalFontManager current fixedWidthFamilies first familyName! !

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/9/2013 23:34'!
fontSize
	^ 10! !

!MudTalkClientTheme methodsFor: 'fill-styles' stamp: 'AlexanderSvyazin 1/9/2013 23:37'!
textEditorNormalFillStyleFor: aTextEditor
	^ Color black! !

!MudTalkClientTheme methodsFor: 'fonts' stamp: 'AlexanderSvyazin 1/26/2013 00:34'!
textFont
	^ LogicalFont
		familyName: (self fixedWidthFontFamily)
		pointSize: self fontSize! !
